/*
 * Stand-alone codes for fuzzy inference systems.
 * J.-S. Roger Jang, 1994.
 * Copyright 1994-2002 The MathWorks, Inc.
 * $Revision: 1.12 $  $Date: 2002/06/17 12:47:24 $
 */

/* This part is for MACs only */
#if defined(applec) || defined(__MWERKS__) || defined (THINK_C) || defined(powerc)

#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <windows.h>

FILE	*output_file;

#define PRINTF macprintf

int macprintf(char* format, ...)	
{
	va_list	arg;
	int		ret;
	
	va_start(arg, format);
	ret = vfprintf(output_file, format, arg);
	va_end(arg);
	
	return(ret);
}
#endif /* applec || __MWERKS__ || THINK_C || powerc */

/* Start of the regular fismain.c */
#include "fis.c"

/***********************************************************************
 Main routine 
 **********************************************************************/

int
main(int argc, char **argv)
{
	FIS *fis;
	int i, j;
	int debug = 0;

int stell;
char sString[1];
long x=20.345678;
int st = 1412;
float o;
int aInt;
char str[15];
float stell1;

	DOUBLE **dataMatrix, **fisMatrix, **outputMatrix;
	char *fis_file, *data_file;
	int data_row_n, data_col_n, fis_row_n, fis_col_n;

#if defined(applec) || defined(__MWERKS__) || defined (THINK_C) || defined(powerc)
	/* For MACs only */
	data_file = "fismain.in";
	fis_file = "fismain.fis";
	output_file = fisOpenFile("fismain.out","w");
#else
	/* input arguments checking */
	if (argc != 3) {
	//	PRINTF("Usage: %s data_file fis_file\n", argv[0]);
	//	exit(1); //Programmbeenden
	}
	/*
	data_file = argv[1];
	fis_file = argv[2];
	*/
	data_file = "inputdata.txt";           //unsigned integer im Bereich von -96 bis +96, Outputwert liegt zwischen 0 - 255 und kann ruhig ein Integerwert sein (ohne Komma)
	fis_file = "fis.fis";
	PRINTF("Starte Fuzzy Logic...\n\n");
	PRINTF("Oeffne COM-Port: 4...\n\n");
#endif /* applec || __MWERKS__ || THINK_C || powerc */

	/* obtain data matrix and FIS matrix */
	dataMatrix = returnDataMatrix(data_file, &data_row_n, &data_col_n);
	fisMatrix = returnFismatrix(fis_file, &fis_row_n, &fis_col_n);

	/* build FIS data structure */
	fis = (FIS *)fisCalloc(1, sizeof(FIS));
	fisBuildFisNode(fis, fisMatrix, fis_col_n, MF_POINT_N);

	/* error checking */
	if (data_col_n < fis->in_n) {
		PRINTF("Given FIS is a %d-input %d-output system.\n",
			fis->in_n, fis->out_n);
		PRINTF("Given data file does not have enough input entries.\n");
		fisFreeMatrix((void **)dataMatrix, data_row_n);
		fisFreeMatrix((void **)fisMatrix, fis_row_n);
		fisFreeFisNode(fis);
		fisError("Exiting ...");
	}

	/* debugging */
	if (debug)
		fisPrintData(fis);

	/* create output matrix */
	outputMatrix = (DOUBLE **)fisCreateMatrix(data_row_n, fis->out_n, sizeof(DOUBLE));

	/* evaluate FIS on each input vector */
	for (i = 0; i < data_row_n; i++)
		getFisOutput(dataMatrix[i], fis, outputMatrix[i]);

	/* print output vector */
	for (i = 0; i < data_row_n; i++) {
		for (j = 0; j < fis->out_n; j++)
	//	PRINTF("y=");
		PRINTF("stellwert = %.12f", outputMatrix[i][j]);
		PRINTF("\n");
	//	float stell;
		stell = outputMatrix[i][j];
	//	y = stell*1000;
	//	stell = stell * 1000;
		x = outputMatrix[i][j];
	//	PRINTF("Stellwert = %i \n\n", stell);
		PRINTF("Stellwert = %.0f \n\n", stell);
		//PRINTF("stellwert = %8.3f", stell);
		
	}
	
	// #################### Daten auf die serielle Schnittstelle schreiben ######################
	
	    //system("mode com4: baud=9600 parity=n data=8 stop=1"); //Port Settings

        int data[] = {10,5,13};  //Random data we want to send     
        FILE *file;     
        file = fopen("COM4:","w");  //Opening device file
        //file = fopen("/dev/ttyUSB0","w");  //Opening device file     
        int z = 0;     
        for(z = 0 ; z < 3 ; z++)     
        {         
            fprintf(file,"%d",data[i]); //Writing to the file         
            fprintf(file,"%c",','); //To separate digits         
           // sleep(1);    
           //_delay_ms(1000); 
        }     
        fclose(file); 
        
        
        //############### stellwert schreiben
        
        file = fopen("COM4:","w"); //Opening device file
      
     //stell=123;
    
        fprintf(file,"\n%.0f", stell); //12 Stellen nach dem Komma darstellen
      
       //st = stell;
      // fprintf(file,"%lf", x); 
        fprintf(file,"\n%i", st); 
      // sprintf(sString, "%-.5f", stell); 
        //sprintf(txtbuf,"%f",stell);
        //fprintf(file, txtbuf);
       /// fprintf(file, "%i", txtbuf);
        
        fprintf(file,"\nDaten erfolgreich gesendet...");
        fclose(file); 
        
        PRINTF("Press ENTER to continou...");
        
	getchar(); //verhindert das Schlieen des Fensters (erst nach Tastendruck) 
	//Alternative: Schleife => Do While
	
	/* clean up memory */
	fisFreeFisNode(fis);
	fisFreeMatrix((void **)dataMatrix, data_row_n);
	fisFreeMatrix((void **)fisMatrix, fis_row_n);
	fisFreeMatrix((void **)outputMatrix, data_row_n);
	exit(0);
	

//Fuzzy Start 

/*double dataMatrix[2];
dataMatrix[1] = 80;
dataMatrix[2] = FehlerALT - dataMatrix [1];


fis->input[0]->value = *dataMatrix;
fisEvaluate(fis,101);
*/
}
